#!/bin/sh

all=analyze-deep-bounds-all.log
rm -f $all
analyze ../archived -v -v|sed -e '/solver/,$d' -e '/discrepancy/,$d' > $all
#echo "generated $all"

solvers=`awk '{print $1}' $all|sort|uniq`
#echo -n "splitting "
for s in $solvers
do
  #echo -n "$s "
  rm -f $s.log
  expand $all | \
  awk "/^$s /"'{print $2,$1,$NF}' |sort -g -k 2 > $s.log
done
#echo

first=yes
#echo -n "joining "
joined=analyze-deep-bounds-joined.log
rm -f joined
for s in $solvers
do
  #echo -n "$s "
  if [ $first = yes ]
  then
    cp $s.log $joined
    first=no
  else
    next=/tmp/analyze-deep-bounds-next-joined.log
    join $joined $s.log > $next
    mv $next $joined
  fi
done
#echo

unsolved=analyze-deep-bounds-unsolved.log
grep -v ' sat ' $joined | grep -v ' uns ' > $unsolved
unsolved=`awk '{print $1}' $unsolved`

bounds=analyze-deep-bounds-list.log
rm -f $bounds
echo "solver    bounds instances"
echo
for s in $solvers
do
  sum=0
  rm -f ${s}-bounds.log
  tipunrolled=0
  for u in $unsolved
  do
    case $s in
      tip*)
        count="`grep ', vrs=' ../archived/$s/$u.log|grep ' k='|sed -e 's,.* k=,,' -e 's/,.*//'|wc -l`"
	[ $count -lt 2 ] && continue
        last="`grep ', vrs=' ../archived/$s/$u.log|grep ' k='|sed -e 's,.* k=,,' -e 's/,.*//'|tail -2|head -1`"
	;;
      *)
	last="`grep '^u[0-9][0-9]*$' ../archived/$s/$u.log|sed -e 's,^u,,'|sort -n|tail -1`"
	;;
    esac
    [ x"$last" = x ] && continue
    case $s in
      tipbmc*)
        unrolled="`grep unrolling ../archived/$s/$u.log|grep cycles|awk '{print $(NF-1)}'`"
	if [ ! x"$unrolled" = x ]
	then
	  last=`expr $last + $unrolled`
	  tipunrolled=`expr $tipunrolled + $unrolled`
	fi
	;;
    esac
    sum=`expr $sum + $last + 1`
    echo "$s $u $last" |tee -a $bounds >> ${s}-bounds.log
  done
  [ -f ${s}-bounds.log ] || continue
  inst="`wc -l ${s}-bounds.log|awk '{print $1}'`"
  case $s in
    blimc*|tarmo*) ss="${s}"'*';;
    *)ss=$s;;
  esac
  printf "%-10s %-6d %-7d" "$ss" $sum $inst
  case $s in
    tipbmc*) echo -n " (incl. $tipunrolled unrolled)";;
    *);;
  esac
  echo
done | sort -n -k 2 -k 1 -r

cat <<EOF

*  = organizer solvers run hors concours
'np' in 'tipnp' & and 'tipbmcnp': no piped output filter
'f' in 'tipf' & 'tipbmcf': added 'fflush' and no piped output
'f' in 'tarmof: added 'fflush' to shell script
'na' in 'tarmona: no scripting

EOF

echo "calculated for the following `echo $unsolved|wc -w` unsolved instances:"
echo
echo $unsolved | fmt -70

