#!/bin/sh
first=yes
plot=""
for i in *-bounds.log
do
  [ x"`wc -l $i`" = x0 ] && continue
  b=`echo $i|sed -e 's,-bounds.log,,'`
  echo $b
  awk '{print $3}' $i|sort -n > $b-data.log
  if [ $first = yes ]
  then
    plot="plot "
    first=no
  else
    plot="$plot, "
  fi
  plot="${plot}\"$b-data.log\" title \"$b\" with lp"
done
script=gnuplot.script
rm -f $script
cat >>$script << EOF
set key at 52,4500 box
set terminal postscript eps enhanced color
set output "deep-bounds-cactus.eps"
set title "Maximum Bounds Distribution Cactus"
set xlabel "instances sorted by maximum bound reached"
set ylabel "maximum bound reached"
set log y
plot "tipbmcf-data.log" title "tipbmcf" with lp, \
     "tarmona-data.log" title "tarmona*" with lp, \
     "blimc-data.log" title "blimc*" with lp, \
     "tipbmcnp-data.log" title "tipbmcnp" with lp, \
     "v3final-data.log" title "v3final" with lp, \
     "aigbmc-data.log" title "aigbmc*" with lp, \
     "v3i-data.log" title "v3i" with lp, \
     "tipbmc-data.log" title "tipbmc" with lp, \
     "tarmo-data.log" title "tarmo*" with lp, \
     "tarmof-data.log" title "tarmof*" with lp, \
     "suprove-data.log" title "suprove" with lp, \
     "tipf-data.log" title "tipf" with lp, \
     "tip-data.log" title "tip" with lp
EOF
#echo "$plot" >> $script
gnuplot $script
